pipeline {

    agent any

    stages {
        
        stage('Clean') {
            steps {
                sh "sh mvnw clean"
            }
        }
        
        stage('Compile') {
            steps {
                sh "sh mvnw compile"
            }
        }

        stage('Test') {
            steps {
                script {
                    docker.image('mysql:5')
                        .withRun("-e 'MYSQL_ROOT_PASSWORD=root123' -e 'MYSQL_DATABASE=curso_db' -p 1122:3306") { c ->
                            sh 'while ! mysqladmin ping -h 0.0.0.0 -P 1122 --silent; do sleep 1; done'
                            sh "sh mvnw test"
                    }
                }
            }
        }

        stage('Package') {
            steps {
                sh "sh mvnw package -DskipTests"
            }
        }

		stage('Docker Build') {
            steps {
                script {

                    /////////// 
                    app = docker.build("registry-itau.mastertech.com.br/image-pedro")

                    /////////// 
                    withCredentials([usernamePassword(
                                            credentialsId: 'registry_credential',
                                            passwordVariable: 'PASSWORD',
                                            usernameVariable: 'USERNAME')
                                        ]) {
                        sh "docker login -p $PASSWORD -u $USERNAME registry-itau.mastertech.com.br"
                    }

                    ///////////    
                    docker.withRegistry('https://registry-itau.mastertech.com.br/image-pedro', 'registry_credential') {
                            app.push("${env.BUILD_NUMBER}")
                            app.push('latest')
                    }
                }
            }
        }
    }
}